"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Validate = void 0;
const __1 = require("..");
const class_transformer_1 = require("class-transformer");
const Joi = require("joi");
function Validate(isTransform = true) {
    return function (target, propertyKey, descriptor) {
        const origin = descriptor.value;
        const paramTypes = __1.getMethodParamTypes(target, propertyKey);
        descriptor.value = function (...args) {
            for (let i = 0; i < paramTypes.length; i++) {
                const item = paramTypes[i];
                const rules = __1.getClassMetadata(__1.RULES_KEY, item);
                if (rules) {
                    const schema = Joi.object(rules);
                    const result = schema.validate(args[i]);
                    if (result.error) {
                        throw result.error;
                    }
                    else {
                        args[i] = result.value;
                    }
                    // passed
                    if (isTransform) {
                        args[i] = class_transformer_1.plainToClass(item, args[i]);
                    }
                }
            }
            return origin.call(this, ...args);
        };
    };
}
exports.Validate = Validate;
//# sourceMappingURL=validate.js.map