"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Func = void 0;
const annotation_1 = require("../annotation");
const __1 = require("..");
function Func(funHandler, functionOptions) {
    if (typeof funHandler !== 'string' && functionOptions === undefined) {
        functionOptions = funHandler;
        funHandler = functionOptions.funHandler || '';
    }
    return (...args) => {
        const [target, key, descriptor] = args;
        // If target is function, @Func annotate class
        if (typeof target === 'function') {
            // save target
            __1.saveModule(__1.FUNC_KEY, target);
            __1.attachClassMetadata(__1.FUNC_KEY, Object.assign({ funHandler }, functionOptions), target);
            // register data
            annotation_1.Scope(__1.ScopeEnum.Request)(target);
        }
        else {
            // If target is instance, @Func annotate class member method
            __1.saveModule(__1.FUNC_KEY, target.constructor);
            __1.attachClassMetadata(__1.FUNC_KEY, Object.assign({
                funHandler,
                key,
                descriptor,
            }, functionOptions), target.constructor);
        }
    };
}
exports.Func = Func;
//# sourceMappingURL=fun.js.map