"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HSFMethod = exports.DubboMethod = exports.GrpcMethod = exports.Provider = void 0;
const __1 = require("../");
const annotation_1 = require("../annotation");
function Provider(type, metadata = {}) {
    return (target) => {
        __1.saveModule(__1.MS_PROVIDER_KEY, target);
        __1.saveClassMetadata(__1.MS_PROVIDER_KEY, {
            type,
            metadata,
        }, target);
        annotation_1.Scope(__1.ScopeEnum.Request)(target);
    };
}
exports.Provider = Provider;
function GrpcMethod(methodName) {
    return (target, propertyName, descriptor) => {
        __1.attachClassMetadata(__1.MS_GRPC_METHOD_KEY, {
            methodName: methodName || propertyName,
        }, target);
        return descriptor;
    };
}
exports.GrpcMethod = GrpcMethod;
function DubboMethod(methodName) {
    return (target, propertyName, descriptor) => {
        __1.attachClassMetadata(__1.MS_DUBBO_METHOD_KEY, {
            methodName: methodName || propertyName,
        }, target);
        return descriptor;
    };
}
exports.DubboMethod = DubboMethod;
function HSFMethod(methodName) {
    return (target, propertyName, descriptor) => {
        __1.attachClassMetadata(__1.MS_HSF_METHOD_KEY, {
            methodName: methodName || propertyName,
        }, target);
        return descriptor;
    };
}
exports.HSFMethod = HSFMethod;
//# sourceMappingURL=provider.js.map