import { MiddlewareParamArray } from '../interface';
export interface RouterOption {
    path?: string;
    requestMethod: string;
    routerName?: string;
    method?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}
export declare const RequestMethod: {
    GET: string;
    POST: string;
    PUT: string;
    DELETE: string;
    PATCH: string;
    ALL: string;
    OPTIONS: string;
    HEAD: string;
};
export declare const RequestMapping: (metadata?: RouterOption) => MethodDecorator;
/**
 * Routes HTTP POST requests to the specified path.
 */
export declare const Post: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP GET requests to the specified path.
 */
export declare const Get: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP DELETE requests to the specified path.
 */
export declare const Del: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP PUT requests to the specified path.
 */
export declare const Put: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP PATCH requests to the specified path.
 */
export declare const Patch: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP OPTIONS requests to the specified path.
 */
export declare const Options: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes HTTP HEAD requests to the specified path.
 */
export declare const Head: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
/**
 * Routes all HTTP requests to the specified path.
 */
export declare const All: (path?: string, routerOptions?: {
    routerName?: string;
    middleware?: MiddlewareParamArray;
    summary?: string;
    description?: string;
}) => MethodDecorator;
//# sourceMappingURL=requestMapping.d.ts.map