"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Broadcast = exports.Emit = exports.OnSocketError = exports.OnMessage = exports.OnDisConnection = exports.OnConnection = exports.WSEventTypeEnum = void 0;
const __1 = require("../");
var WSEventTypeEnum;
(function (WSEventTypeEnum) {
    WSEventTypeEnum["ON_CONNECTION"] = "ws:onConnection";
    WSEventTypeEnum["ON_DISCONNECTION"] = "ws:onDisconnection";
    WSEventTypeEnum["ON_MESSAGE"] = "ws:onMessage";
    WSEventTypeEnum["ON_SOCKET_ERROR"] = "ws:onSocketError";
    WSEventTypeEnum["EMIT"] = "ws:Emit";
    WSEventTypeEnum["BROADCAST"] = "ws:broadcast";
})(WSEventTypeEnum = exports.WSEventTypeEnum || (exports.WSEventTypeEnum = {}));
function OnConnection() {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.ON_CONNECTION,
            propertyName: propertyKey,
            descriptor,
        }, target.constructor);
    };
}
exports.OnConnection = OnConnection;
function OnDisConnection() {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.ON_DISCONNECTION,
            propertyName: propertyKey,
            descriptor,
        }, target.constructor);
    };
}
exports.OnDisConnection = OnDisConnection;
function OnMessage(eventName) {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.ON_MESSAGE,
            messageEventName: eventName,
            propertyName: propertyKey,
            descriptor,
        }, target.constructor);
    };
}
exports.OnMessage = OnMessage;
function OnSocketError(eventName) {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.ON_SOCKET_ERROR,
            messageEventName: eventName,
            propertyName: propertyKey,
            descriptor,
        }, target.constructor);
    };
}
exports.OnSocketError = OnSocketError;
function Emit(messageName, roomName = []) {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.EMIT,
            propertyName: propertyKey,
            messageEventName: messageName,
            roomName: [].concat(roomName),
            descriptor,
        }, target.constructor);
    };
}
exports.Emit = Emit;
function Broadcast() {
    return (target, propertyKey, descriptor) => {
        __1.attachClassMetadata(__1.WS_EVENT_KEY, {
            eventType: WSEventTypeEnum.BROADCAST,
            propertyName: propertyKey,
            descriptor,
        }, target.constructor);
    };
}
exports.Broadcast = Broadcast;
//# sourceMappingURL=webSocketEvent.js.map